#include "fe_piece.h"

#include "defines.h"

const FEForm FE_FORMS[FE_NB_FORMS] = {
	{ {  0, -1 },
	  {  0,  0 } }
};

const QColor FE_COLORS[FE_NB_COLORS] = {
	QColor(100, 200, 100),
	QColor(100, 200, 200),
	QColor(200, 100, 100),
	QColor(200, 100, 200),
	QColor(200, 200, 200) // white blocks
};

void FEPiece::generateNext(int _type)
{
	FEPieceInfo info;
	type = (_type==-1 ? randomInt(0, info.nbTypes()-1, seed) : (uint)_type );
	for (uint k=0; k<blocks.size(); k++) {
		blocks[k].x     = info.x(0)[k];
		blocks[k].y     = info.y(0)[k];
		blocks[k].value = (k%2 ? type/4 : type%4) + 1;
	}
}

uint FEPiece::nbConfigurations() const
{
	return FEPieceInfo().nbConfigurations(type);
}
