#ifndef FE_PIECE_H
#define FE_PIECE_H

#include "gpiece.h"

const uint FE_NB_BLOCKS = 2;
const uint FE_NB_FORMS  = 1;
const uint FE_NB_TYPES  = 4 * 4;
const uint FE_NB_COLORS = 4 + 1;

typedef struct {
	int x[FE_NB_BLOCKS];
	int y[FE_NB_BLOCKS];
} FEForm;

extern const FEForm FE_FORMS[FE_NB_FORMS];
extern const QColor FE_COLORS[FE_NB_COLORS];

class FEPieceInfo : public GPieceInfo
{
 public:
	FEPieceInfo() {}

	uint nbBlocks() const { return FE_NB_BLOCKS; }
	uint nbForms()  const { return FE_NB_FORMS;  }
	uint nbTypes()  const { return FE_NB_TYPES;  }

	const int *x(uint form) const { return FE_FORMS[form].x; }
	const int *y(uint form) const { return FE_FORMS[form].y; }
	uint nbConfigurations(uint type) const
		{ return ((type%4)==(type/4) ? 2 : 4);}
};

class FEPiece : public GPiece
{
public:
    FEPiece() : GPiece(FEPieceInfo().nbBlocks()) {}
	FEPiece(const FEPiece &p) : GPiece(p) {}

	uint nbConfigurations() const;
	void generateNext(int type = -1);
};

#endif
