#include "tl_piece.h"

#include "defines.h"

//-----------------------------------------------------------------------------
const TLForm TL_FORMS[TL_NB_FORMS] = {
	{ {  0,  0, -1, -1 },
	  { -1,  0,  0,  1 }, 2 }, // red broken line
	{ {  0,  0,  1,  1 },
	  { -1,  0,  0,  1 }, 2 }, // green broken line
	{ {  0,  0,  0,  0 },
	  { -1,  0,  1,  2 }, 2 }, // blue line
	{ { -1,  0,  1,  0 },
	  {  0,  0,  0,  1 }, 4 }, // orange T
	{ { -1,  0, -1,  0 },
	  {  0,  0,  1,  1 }, 1 }, // violet square
	{ { -1,  0,  0,  0 },
	  { -1, -1,  0,  1 }, 4 }, // backward L
	{ {  1,  0,  0,  0 },
	  { -1, -1,  0,  1 }, 4 }  // real L
};

const QColor TL_COLORS[TL_NB_COLORS] = {
	QColor(200, 100, 100),
	QColor(100, 200, 100),
	QColor(100, 100, 200),
	QColor(200, 200, 100),
	QColor(200, 100, 200),
	QColor(100, 200, 200),
	QColor(218, 170,   0),
	QColor(100, 100, 100)  // gray blocks
};

//-----------------------------------------------------------------------------
void TLPiece::generateNext(int _type)
{
	TLPieceInfo info;
	type = (_type==-1 ? randomInt(0, info.nbTypes()-1, seed) : (uint)_type );

	for (uint i=0; i<blocks.size(); i++) {
		blocks[i].x     = info.x(type)[i];
		blocks[i].y     = info.y(type)[i];
		blocks[i].value = type + 1;
	}
}

uint TLPiece::nbConfigurations() const
{
	return TLPieceInfo().nbConfigurations(type);
}
