#ifndef TL_PIECE_H
#define TL_PIECE_H

#include "gpiece.h"

const uint TL_NB_BLOCKS = 4;
const uint TL_NB_FORMS  = 7;
const uint TL_NB_TYPES  = TL_NB_FORMS;
const uint TL_NB_COLORS = TL_NB_FORMS + 1;

typedef struct {
	int x[TL_NB_BLOCKS];
	int y[TL_NB_BLOCKS];
	uint nbConfigs;
} TLForm;

extern const TLForm TL_FORMS[TL_NB_FORMS];
extern const QColor TL_COLORS[TL_NB_COLORS];

class TLPieceInfo : public GPieceInfo
{
 public:
	TLPieceInfo() {}

	uint nbBlocks() const { return TL_NB_BLOCKS; }
	uint nbForms()  const { return TL_NB_FORMS;  }
	uint nbTypes()  const { return TL_NB_TYPES;  }

	const int *x(uint form) const { return TL_FORMS[form].x; }
	const int *y(uint form) const { return TL_FORMS[form].y; }
	uint nbConfigurations(uint type) const { return TL_FORMS[type].nbConfigs; }
};

class TLPiece : public GPiece
{
public:
    TLPiece() : GPiece(TLPieceInfo().nbBlocks()) {}
	TLPiece(const TLPiece &p) : GPiece(p) {}

	uint nbConfigurations() const;
	void generateNext(int type = -1);
};

#endif
